

/**  class cNeuralTrainSetItem **/
function cNeuralTrainSetItem(adInputValues, adOutputValuesWanted){
	this.adI = adInputValues;
	this.adO = adOutputValuesWanted;
}
cNeuralTrainSetItem.prototype = {
	GetDifference: function(adOutputValuesReal){
		var dSumReal = 0;
		for( var i in adOutputValuesReal )
			dSumReal += adOutputValuesReal[i];
	}
};


/**  class cNeuralTrainSet **/
function cNeuralTrainSet(){
	this.aoItems = new Array();
	this._iIndex = 0;
}
cNeuralTrainSet.prototype = {
	Add: function(oTrainSetItem){
		this.aoItems.push(oTrainSetItem);
	},
	Clear: function(){ this.aoItems = new Array(); this._iIndex = 0; },
	
	GetAt: function(iIndex){
		if( iIndex < this.aoItems.length )
			return this.aoItems[iIndex];
	},
	GetRandom: function(){
		var iIndex = Math.floor(Math.random() * this.aoItems.length) % this.aoItems.length;
		return this.aoItems[iIndex];
	},


	// Iterator related 
	resetIterator: function(){ this._iIndex = 0; },
	hasNext:       function(){ return ( this._iIndex < this.aoItems.length ); },
	next:          function(){ return this.aoItems[this._iIndex++]; }
};





/**************************************************************
    class cNeuralNetTeacher                                    
	Implementation of supervised learning with backpropagation   
**************************************************************/
function cNeuralNetTeacher(oNeuralNetIOAdapter, oTrainSet, dLearn, dMomentum, dTargetError, iMaxRepeats){

	this.oNetAdapter = oNeuralNetIOAdapter;
	this.oTrainSet   = oTrainSet;
	this.oCurTrainSetItem = null;
	
	this.dLearn = dLearn ? dLearn : 0.2;                       // Learning rate - correction amount (LAMBDA) 
	this.dMomentum = dMomentum ? dMomentum : 0.05;             // Momentum - net's momentum (setrvanost)    
	this.iMaxRepeats  = iMaxRepeats ? iMaxRepeats : 1000;      // Maximum mumber of repeats of training step 
	this.dTargetError = dTargetError ? dTargetError : 0.03;    // Target error - stop training when reached  
	
	
	this.iTurns = 0;
	this.iCorrections = 0;
	this.dLastErrorSum = null;
	this.adErrorSums = new Array();
	this.oAvgErrorSums = new cAverage();
		
	this.oAvgCorrectionTime = new cAverage();
	this.iLastTimeMs = 0;
	
}
cNeuralNetTeacher.prototype = {
	GetNet:      function(){ return this.oNetAdapter.oNeuralNet; },
	GetErrorSum: function(){ return this.dLastErrorSum; },

	GetTurnsCount: function(){ return this.iTurns; },
	GetCorrectionsCount: function(){ return this.iCorrections; },
	ResetCounters: function(){ this.iTurns  = 0; this.iCorrections = 0; },

	// Jedno kolo uen - vybrn vstupu a vpoet. 
	Turn: function(){
		this.iTurns++;
		this.oCurTrainSetItem = this.oTrainSet.GetRandom();
		//this.oCurTrainSetItem = this.oTrainSet.GetAt(2);
		if(_dw) _dw.Write("Vstupn hodnoty: [" + this.oCurTrainSetItem.adI + "]"); ///
		if(_dw) _dw.Write("Chtn  hodnoty: [" + this.oCurTrainSetItem.adO + "]"); ///

		this.oNetAdapter.SetInputValues(this.oCurTrainSetItem.adI);
		this.oNetAdapter.oNeuralNet.Compute();
	},
	

	
	/*********************************************************************************
	  cNeuralNetTeacher::PerformCorrection()                                          
		Pizpsoben st: Porovnn rozdlu a oprava vah. 
		
		Koncept prochzen st:
		
		- Jsou dv mnoiny:              (lib.cSet.js)
		  - setDoneNeurons - uchovv neurony se spotenm errorem 
		  - setNextNeurons - obsahuje kandidty na vpoet v dalm kole (while)
		- V kadm kole se projdou kandidti a zjist se, jestli vechny jejich 
		  odchoz synapse vedou do ji spotench neuron (setDoneNeurons.has(...)).
		  - Pokud ne, neuron se ponech mezi kandidty.
		  - Pokud ano, neuron se spote (dError),
		    odstran se z kandidt (setNextNeurons.remove(...)),
		    vlo se do spotench (setDoneNeurons.put()),
		    a neurony do nj vchzejc se pidaj do kandidt (setNextNeurons.put()).
		- Tento algoritmus nefunguje, pokud s obsahuje smyky.
		- Plnuju algoritmus dt pmo do cNeuralNetwork, kde by ml za kol rozhodnout
		  o tom, jestli s obsahuje smyky, a pokud ne, sestavit poad vpotu.
		
	*********************************************************************************/
	PerformCorrection: function(){
		this.iCorrections++;
		//var _dw = null;
		
		var oTimeStart = new Date();
	
		var oNeuralNet = this.oNetAdapter.oNeuralNet;
		
		// Zskn hodnot 
		var adVystupyReal = this.oNetAdapter.GetOutputValues();
		var adVystupyWant = this.oCurTrainSetItem.adO;
		if(adVystupyWant.length < adVystupyReal.length)
			return false;
			
		var s = ArrayMap( adVystupyReal, function(d){ return Round(d,4); } );
		if(_dw) _dw.Write("Vstupn hodnoty: [" + s + "]"); ///

		//var adVystupyDiff = new Array();
		//var adWeightDeltas = new Array();
		var dErrorSum = 0;
		
		/*for( var i in adVystupyReal ){
			//dErrorSum += adVystupyDiff[i] = adVystupyWant[i] - adVystupyReal[i];
			//adWeightDeltas[i] = this.oNetAdapter.oNeuralNet.fFunc( adVystupyReal[i] ) * adVystupyDiff[i];
			// error = OutReal * (1  OutReal) * (OutWant  OutReal)
		}/**/
			

		// Pracovn prostor... 
		var aoCurNeurons;
		var setNextNeurons = new cSet();
		var setDoneNeurons = new cSet();
		var oCurNeuron;
		var _iRounds = 0;
		
		
		/* ----------------- Vstupn vrstva ----------------- */
		
		if(_dw) _dw.Write("."); ///
		if(_dw) _dw.Write("Starting backprop round # -1  - output layer"); ///
			
		// Pro vechny vstupn neurony st - nastavme jim Error. 
		for( var i in oNeuralNet.aoOutputNeurons ){
			var oCurNeuron  = oNeuralNet.aoOutputNeurons[i];
			  if(_dw) _dw.Write("- Correcting "+(oCurNeuron.toStringFull())+""); ///
			setDoneNeurons.put(oCurNeuron);

			// -- http://www.tek271.com/articles/neuralNet/IntoToNeuralNets.html -- 
			        /* derivace Sigmoidy */          /* dDiff */
			// e =  (   z * (1  z)       )     *     ( y  z );    z == dOutReal,  y == dOutWant 
			
			// Rozdl mezi vstupem a vstupem 
			var dOutReal = oCurNeuron.dValue;
			var dDiff = adVystupyWant[i] - dOutReal;
			// Chyba tohoto vst. neur.
			oCurNeuron.dError = oCurNeuron.fFunc.derivation(dOutReal) * dDiff;
			  if(_dw) _dw.Write("("+oCurNeuron.id+") diff: "+Round(dDiff, 5)+" err: "+Round(oCurNeuron.dError, 5)); ///
			dErrorSum += Math.abs(oCurNeuron.dError);

			// Dq = e * lambda;
			var dPom = oCurNeuron.dError * this.dLearn;
			  if(_dw) _dw.Write("("+oCurNeuron.id+") err * lambda: " +Round(dPom, 5)); ///
				
			oCurNeuron.dBias += dPom;
			
			for( var j in oCurNeuron.aRecep ){
				var oSynapseIn = oCurNeuron.aRecep[j];
				// Dw[i] = Dq * vstup_neuronu[i]; 
				oSynapseIn.dWeight += dPom * oSynapseIn.GetInput(); /// Dno do neuronu 
				setNextNeurons.put(oSynapseIn.oFrom);
			}
			if(_dw) _dw.Write("+ Corrected "+(oCurNeuron.toStringFull())+""); ///
		}
		aoCurNeurons = setNextNeurons.getMembers();
		//setNextNeurons.clear();     // Neurony se odstrauj, kdy jsou spoten. 



		// --- Zpracovn error sum --- //
		this.dLastErrorSum = dErrorSum;
  		if(_dw) _dw.Write("Error Sum: " +Round(dErrorSum, 5)); ///
		this.adErrorSums.push(dErrorSum);
		if(dErrorSum < this.dTargetError)
			; // Nco udlat. 
			
		
		
		aoCurNeurons = this.oNetAdapter.oNeuralNet.aoNeuronsOrder;
		// Neurony z vstupn vrstvy u potat nebudeme. 
		var aoCurNeurons2 = new Array();
		for( var i in aoCurNeurons ){
			if( !setDoneNeurons.has(aoCurNeurons[i]) )
				aoCurNeurons2.push( aoCurNeurons[i] );
		}/**/
		aoCurNeurons = aoCurNeurons2;
		
		

		/* ----------------- Zbyl vrstvy... ----------------- */

		// Dokud jsou ve front na vpoet njak neurony... 
		while(aoCurNeurons.length > 0) {
			if(_dw) _dw.Write("."); ///
			if(_dw) _dw.Write("Starting backprop round #"+(_iRounds++)+""); ///

			try{
			// Pro vechny neurony ve front na vpoet v tomto kole... 
			for_aoCurNeurons:
			for( var i in aoCurNeurons ){
				oCurNeuron = aoCurNeurons[i];
				  if(_dw) _dw.Write("- Correcting "+(oCurNeuron.toStringFull())+""); ///
					
				// Pokud u je neuron hotov, vyndme ho z fronty a peskome.
				// Tk se vstupn vrstvy - poad vpotu je vypoten pedem. 
				// if( !setDoneNeurons.has(oCurNeuron) ) continue;
				// Tak nakonec ne - vyfiltruju si to u ped cyklem.
				
				// Seteme errory z navazujcch neuron, vynsoben vahami synaps do nich  [ g = SUM( m[i] * e[i] ) ]
				var dErrorSum = 0.0;
				for( var j in oCurNeuron.aTrans ){
					var oSynapseOut = oCurNeuron.aTrans[j];
					dErrorSum += oSynapseOut.oTo.dError * oSynapseOut.dWeight;
				}
				
				// Uloen chyby tohoto vst. neur.
				oCurNeuron.dError = dErrorSum * oCurNeuron.fFunc.derivation(oCurNeuron.dValue);
					//if(_dw) _dw.Write("("+oCurNeuron.id+")  err: "+Round(oCurNeuron.dError, 5)); ///

				var dPom  = oCurNeuron.dError * this.dLearn;

				oCurNeuron.dBias += dPom;

					//if(_dw) _dw.Write("- Following: [ "+(oCurNeuron.aRecep)+" ]"); ///
				// Pro vechny pedchzejc neurony... 
				for( var j in oCurNeuron.aRecep ){
					var oFromNeuron = oCurNeuron.aRecep[j].oFrom;
					if( oFromNeuron == null )  continue;
					// upravme vhy synaps vedoucch z nj sem, 
					oCurNeuron.aRecep[j].dWeight += oFromNeuron.dValue * dPom;
				}
				
				if(_dw) _dw.Write("+ Corrected "+(oCurNeuron.toStringFull())+""); ///
				
			}// for( var i in aoCurNeurons )			
			}catch(e){ _dw.Write("... Exception " + e); throw e; }
			
			// V setNextNeurons mme mnoinu neuron na dal kolo backpropagation. 
			//aoCurNeurons = setNextNeurons.getMembers();
			break;

		}// while()
		
		
		this.iLastTimeMs = (new Date()).getTime() - oTimeStart.getTime();
		this.oAvgCorrectionTime.AddSample( this.iLastTimeMs );
		this.oAvgErrorSums.AddSample( this.dLastErrorSum );
		if( this.iCorrections >= 20 )
			this.oAvgErrorSums.RemSample( this.adErrorSums[this.adErrorSums.length-20] );
		
		
		
		if(_dw) _dw.Write("."); ///
		if(window._dw) window._dw.Write("Correcting finished. Time: "+this.iLastTimeMs+" ms; Overall avg time: "+this.oAvgCorrectionTime+" ms"); ///
		
		return true;

	}, // cNeuralNetTeacher.prototype.PerformCorrection() 
	
	
	/** Vrac prmr z poslednch iCorrections opravovn. */
	GetErrorSumsAvg: function(iCorrections, iBackOffset){
		if(iCorrections == null){
			return this.oAvgErrorSums.GetAverage();
		}
	
		if(iBackOffset == null) iBackOffset = 0;
		var iIndex1 = Math.max(0, this.adErrorSums.length - iCorrections - iBackOffset);
		var iIndex2 = Math.max(0, this.adErrorSums.length - 1 - iBackOffset);
		
		var dAvg = 0.0;
		for( var i = iIndex1; i < iIndex2; i++ ){
			dAvg += this.adErrorSums[i];
		}
		return dAvg / (iIndex2 - iIndex1 + 1);
	}
	
	
	
}; // class cNeuralNetTeacher prototype





/*
	oVzor = oTrainSet.GetRandom();
	oVzor = aoadVzory[2];
	
	_dw.Write("Vstupn hodnoty: [" + oVzor.adI + "]"); ///

	oNetAdapter.SetInputValues(oVzor.adI);
	oNetAdapter.oNeuralNet.Compute();

	var adVystupyReal = oNetAdapter.GetOutputValues();
	var dError = oNetAdapter.GetError();

	var s = ArrayMap( adVystupyReal, function(d){ return RoundPrec(d, 100); } );
	_dw.Write("Vstupn hodnoty: " + s); ///
	
	for( var i = 0; i < 10; i++){
		if(_dw) _dw.Write("--- oNetTeacher.Turn(); ---"); ///
		oNetTeacher.Turn();
		if(_dw) _dw.Write("--- oNetTeacher.PerformCorrection(); ---"); ///
		oNetTeacher.PerformCorrection();
	}
*/