	/*********************************************************************************
	  cNeuralNetTeacher::PerformCorrection()                                          
		Pizpsoben st: Porovnn rozdlu a oprava vah. 
		
		Koncept prochzen st:
		
		- Jsou dv mnoiny:              (lib.cSet.js)
		  - setDoneNeurons - uchovv neurony se spotenm errorem 
		  - setNextNeurons - obsahuje kandidty na vpoet v dalm kole (while)
		- V kadm kole se projdou kandidti a zjist se, jestli vechny jejich 
		  odchoz synapse vedou do ji spotench neuron (setDoneNeurons.has(...)).
		  - Pokud ne, neuron se ponech mezi kandidty.
		  - Pokud ano, neuron se spote (dError),
		    odstran se z kandidt (setNextNeurons.remove(...)),
		    vlo se do spotench (setDoneNeurons.put()),
		    a neurony do nj vchzejc se pidaj do kandidt (setNextNeurons.put()).
		- Tento algoritmus nefunguje, pokud s obsahuje smyky.
		- Plnuju algoritmus dt pmo do cNeuralNetwork, kde by ml za kol rozhodnout
		  o tom, jestli s obsahuje smyky, a pokud ne, sestavit poad vpotu.
		
	- Tato verze u pouv pedvypoten poad zpracovn neuron, ale stle 
	  obsahuje
	*********************************************************************************/
cNeuralNetTeacher.prototype.PerformCorrection = function(){
		this.iCorrections++;
		//var _dw = null;
		
		var oTimeStart = new Date();
	
		var oNeuralNet = this.oNetAdapter.oNeuralNet;
		
		// Zskn hodnot 
		var adVystupyReal = this.oNetAdapter.GetOutputValues();
		var adVystupyWant = this.oCurTrainSetItem.adO;
		if(adVystupyWant.length < adVystupyReal.length)
			return false;
			
		var s = ArrayMap( adVystupyReal, function(d){ return Round(d,4); } );
		if(_dw) _dw.Write("Vstupn hodnoty: [" + s + "]"); ///

		//var adVystupyDiff = new Array();
		//var adWeightDeltas = new Array();
		var dErrorSum = 0;
		
		/*for( var i in adVystupyReal ){
			//dErrorSum += adVystupyDiff[i] = adVystupyWant[i] - adVystupyReal[i];
			//adWeightDeltas[i] = this.oNetAdapter.oNeuralNet.fFunc( adVystupyReal[i] ) * adVystupyDiff[i];
			// error = OutReal * (1  OutReal) * (OutWant  OutReal)
		}/**/
			

		// Pracovn prostor... 
		var aoCurNeurons;
		var setNextNeurons = new cSet();
		var setDoneNeurons = new cSet();
		var oCurNeuron;
		var _iRounds = 0;
		
		
		/* ----------------- Vstupn vrstva ----------------- */
		
		if(_dw) _dw.Write("."); ///
		if(_dw) _dw.Write("Starting backprop round # -1  - output layer"); ///
			
		// Pro vechny vstupn neurony st - nastavme jim Error. 
		for( var i in oNeuralNet.aoOutputNeurons ){
			var oCurNeuron  = oNeuralNet.aoOutputNeurons[i];
			  if(_dw) _dw.Write("- Correcting "+(oCurNeuron.toStringFull())+""); ///
			setDoneNeurons.put(oCurNeuron);

			// -- http://www.tek271.com/articles/neuralNet/IntoToNeuralNets.html -- 
			        /* derivace Sigmoidy */          /* dDiff */
			// e =  (   z * (1  z)       )     *     ( y  z );    z == dOutReal,  y == dOutWant 
			
			// Rozdl mezi vstupem a vstupem 
			var dOutReal = oCurNeuron.dValue;
			var dDiff = adVystupyWant[i] - dOutReal;
			// Chyba tohoto vst. neur.
			oCurNeuron.dError = oCurNeuron.fFunc.derivation(dOutReal) * dDiff;
			  if(_dw) _dw.Write("("+oCurNeuron.id+") diff: "+Round(dDiff, 5)+" err: "+Round(oCurNeuron.dError, 5)); ///
			dErrorSum += Math.abs(oCurNeuron.dError);

			// Dq = e * lambda;
			var dPom = oCurNeuron.dError * this.dLearn;
			  if(_dw) _dw.Write("("+oCurNeuron.id+") err * lambda: " +Round(dPom, 5)); ///
			
			for( var j in oCurNeuron.aRecep ){
				var oSynapseIn = oCurNeuron.aRecep[j];
				// Dw[i] = Dq * vstup_neuronu[i]; 
				oSynapseIn.dWeight += dPom * oSynapseIn.GetInput(); /// Dno do neuronu 
				setNextNeurons.put(oSynapseIn.oFrom);
			}
			if(_dw) _dw.Write("+ Corrected "+(oCurNeuron.toStringFull())+""); ///
		}
		aoCurNeurons = setNextNeurons.getMembers();
		//setNextNeurons.clear();     // Neurony se odstrauj, kdy jsou spoten. 


		// --- Zpracovn error sum --- //
		this.dLastErrorSum = dErrorSum;
  		if(_dw) _dw.Write("Error Sum: " +Round(dErrorSum, 5)); ///
		this.adErrorSums.push(dErrorSum);
		if(dErrorSum < this.dTargetError)
			; // Nco udlat. 
			
		
		
		aoCurNeurons = this.oNetAdapter.oNeuralNet.aoNeuronsOrder;
		// Neurony z vstupn vrstvy u potat nebudeme. 
		var aoCurNeurons2 = new Array();
		for( var i in aoCurNeurons ){
			if( !setDoneNeurons.has(aoCurNeurons[i]) )
				aoCurNeurons2.push( aoCurNeurons[i] );
		}/**/
		aoCurNeurons = aoCurNeurons2;
		
		

		/* ----------------- Zbyl vrstvy... ----------------- */

		// Dokud jsou ve front na vpoet njak neurony... 
		while(aoCurNeurons.length > 0) {
			if(_dw) _dw.Write("."); ///
			if(_dw) _dw.Write("Starting backprop round #"+(_iRounds++)+""); ///

			try{
			// Pro vechny neurony ve front na vpoet v tomto kole... 
			for_aoCurNeurons:
			for( var i in aoCurNeurons ){
				oCurNeuron = aoCurNeurons[i];
				  if(_dw) _dw.Write("- Correcting "+(oCurNeuron.toStringFull())+""); ///
					
				// Pokud u je neuron hotov, vyndme ho z fronty a peskome.
				// Tk se vstupn vrstvy - poad vpotu je vypoten pedem. 
				// if( !setDoneNeurons.has(oCurNeuron) ) continue;
				// Tak nakonec ne - vyfiltruju si to u ped cyklem.
				
				// Seteme errory z navazujcch neuron, vynsoben vahami synaps do nich  [ g = SUM( m[i] * e[i] ) ]
				var dErrorSum = 0.0;
				for( var j in oCurNeuron.aTrans ){
					var oSynapseOut = oCurNeuron.aTrans[j];
					// Pokud neuron jet nem spoten dError, peskome ho, a nechme ho jet ve front na zpracovn. 
					if( !setDoneNeurons.has(oSynapseOut.oTo) ){
							if(_dw) _dw.Write("-- Skipping - has synapse to non-ready neuron."); ///
						break for_aoCurNeurons;
					}
					dErrorSum += oSynapseOut.oTo.dError * oSynapseOut.dWeight;
				}
				
				// Uloen chyby tohoto vst. neur.
				oCurNeuron.dError = dErrorSum * oCurNeuron.fFunc.derivation(oCurNeuron.dValue);
					if(_dw) _dw.Write("("+oCurNeuron.id+")  err: "+Round(oCurNeuron.dError, 5)); ///
				setDoneNeurons.put(oCurNeuron);     // Pidme zpracovvan neuron mezi hotov (m spoten error). 
				setNextNeurons.remove(oCurNeuron);  // Odstranme zpracovvan neuron z fronty na zpracovn.
				

				var dPom  = oCurNeuron.dError * this.dLearn;

					//if(_dw) _dw.Write("- Following: [ "+(oCurNeuron.aRecep)+" ]"); ///
			
				// Pro vechny pedchzejc neurony... 
				for( var j in oCurNeuron.aRecep ){
					var oFromNeuron = oCurNeuron.aRecep[j].oFrom;
					if( oFromNeuron == null )  continue;
					
					// upravme vhy synaps vedoucch z nj sem, 
					oCurNeuron.aRecep[j].dWeight += oFromNeuron.dValue * dPom;
					// a pokud u nen upraven, 
					if( !setDoneNeurons.has(oFromNeuron) ){						
						// pidme ho do fronty na vpoet v dalm kole. 
						setNextNeurons.put(oFromNeuron);
					}
				}
				
				if(_dw) _dw.Write("+ Corrected "+(oCurNeuron.toStringFull())+""); ///
				
			}// for( var i in aoCurNeurons )			
			}catch(e){ _dw.Write("... Exception " + e); throw e; }
			
			// V setNextNeurons mme mnoinu neuron na dal kolo backpropagation. 
			aoCurNeurons = setNextNeurons.getMembers();
			//setNextNeurons.clear();     // Neurony se odstrauj, kdy jsou spoten. 

		}// while()
		
		
		this.iLastTimeMs = (new Date()).getTime() - oTimeStart.getTime();
		this.oAvgCorrectionTime.AddSample( this.iLastTimeMs );
		
		if(_dw) _dw.Write("."); ///
		if(window._dw) window._dw.Write("Correcting finished. Time: "+this.iLastTimeMs+" ms; Overall avg time: "+this.oAvgCorrectionTime+" ms"); ///
		
		
		return true;

	}; // cNeuralNetTeacher.prototype.PerformCorrection() 